/***********************************************************
 * $Id: FCKEditor.java 103 2008-03-17 13:39:57Z lech $
 * 
 * Tapestry Tools
 * 
 * Copyleft (C) 2007 IBCL and EV-i Informationstechnologie GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *  
 * Created: 26.12.2007
 *
 * Author: lech
 * 
 * Based on:
 *     org.hannebauer.tapestry.component.jseditor.JSEditor
 * by  Robert Hannebauer
 * see http://www.hannebauer.org/content/view/78/101/
 * 
 ***********************************************************/

package org.clazzes.tapestry.tools.components;

import java.util.HashMap;
import java.util.Map;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.IScript;
import org.apache.tapestry.PageRenderSupport;
import org.apache.tapestry.TapestryUtils;
import org.apache.tapestry.annotations.ComponentClass;
import org.apache.tapestry.annotations.InjectScript;
import org.apache.tapestry.annotations.Parameter;

/**
 * Base class of all WYSIWIG Javascript Editors
 * 
 * @author Robert Hannebauer
 */
@ComponentClass(allowBody = false, allowInformalParameters = false)
public abstract class FCKEditor extends AbstractComponent {

    @Parameter(required = false, defaultValue = "literal:200px")
    public abstract String getHeight();

    @Parameter(required = false, defaultValue = "literal:100%")
    public abstract String getWidth();

    @Parameter(required = true)
    public abstract String getTextAreaId();

    /**
     * @return "Default" and "Basic", future version should support custom toolbarsets 
     */
    @Parameter(required = false, defaultValue = "literal:Default")
    public abstract String getToolbarSet();

    @InjectScript("form/fckeditor.script")
    public abstract IScript getScript();

    /* (non-Javadoc)
     * @see org.apache.tapestry.AbstractComponent#renderComponent(org.apache.tapestry.IMarkupWriter, org.apache.tapestry.IRequestCycle)
     */
    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle) {

        boolean isRender = !cycle.isRewinding();

        if (isRender) {
            PageRenderSupport pageRenderSupport = TapestryUtils
                    .getPageRenderSupport(cycle, this);
            Map<String,String> symbols = new HashMap<String,String>();
            symbols.put("textAreaId", getTextAreaId());
            symbols.put("width", getWidth());
            symbols.put("height", getHeight());
            symbols.put("toolbarSet", getToolbarSet());
            getScript().execute(this, cycle, pageRenderSupport, symbols);
        }
    }
}
