/***********************************************************
 * $Id: HelloWorld.java 42 2007-08-24 15:05:52Z wglas $
 * 
 * Tapestry Tools
 * 
 * Copyleft (C) 2007 IBCL and EV-i Informationstechnologie GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *  
 * Created: 05.06.2007
 *
 * Author: lech
 * 
 ***********************************************************/

package org.clazzes.tapestry.tools.components;

import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.ITemplateComponent;
import org.apache.tapestry.annotations.ComponentClass;
import org.apache.tapestry.engine.IPageLoader;
import org.apache.tapestry.spec.IComponentSpecification;
import org.clazzes.tapestry.tools.I18nHelper;
import org.xnap.commons.i18n.I18n;


/**
 * This is a HelloWorld component created to learn and show how a simple Tapestry Component works. 
 * 
 * @author lech
 *
 */
@ComponentClass(allowBody=false,allowInformalParameters=true)
public abstract class HelloWorld extends BaseComponent  implements ITemplateComponent {

  /* (non-Javadoc)
   * @see org.apache.tapestry.BaseComponent#renderComponent(org.apache.tapestry.IMarkupWriter, org.apache.tapestry.IRequestCycle)
   */
  @Override
  protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle) {
      
      I18n i18n = I18nHelper.getI18n(this);
      
      writer.begin("b");
      writer.closeTag();
      writer.print(i18n.tr("Hello World!"));
      writer.end();
  }
  
  /* (non-Javadoc)
   * @see org.apache.tapestry.BaseComponent#finishLoad(org.apache.tapestry.IRequestCycle, org.apache.tapestry.engine.IPageLoader, org.apache.tapestry.spec.IComponentSpecification)
   */
  @Override
  public void finishLoad(IRequestCycle cycle, IPageLoader loader, IComponentSpecification specification)
  {
      super.finishLoad();
  }
  
}
