	function parseDate(dateStr){
		var datePat = /^[\d]{4,4}(-|\.)[\d]{1,2}(-|\.)[\d]{1,2}$/;
		
		var matchArray = dateStr.match(datePat); // is the format ok?
		if (matchArray == null) {
			if (dateStr!= "")
    	        alert("Das eingegebene Datum \""+dateStr+"\" besitzt kein korrektes Format (yyyy-MM-dd).");
			return "-2";
		}
		
		monthE = ""; // parse date into variables
		dayE = "";
		yearE = "";
		
		dateStr = dateStr.replace("\.","-");
		
		// alert(dateStr);
		var i;
		
		for(i =0; i<dateStr.length; i++){
			if(dateStr.charAt(i) != '-'){
				yearE += dateStr.charAt(i);
			}else{
				i++; break;
			}
		}
		
		for(; i<dateStr.length; i++){
			if(dateStr.charAt(i) != '-'){
				monthE += dateStr.charAt(i);
			}else{
				i++; break;
			}
		}
		
		for(; i<dateStr.length; i++){
			if(dateStr.charAt(i) != '-'){
				dayE += dateStr.charAt(i);
			}else{
				break;
			}
		}
		
		if (monthE < 1 || monthE > 12) { // check monthE range
		alert("Der Monat muss zwischen 1 and 12 liegen.");
		return "-2";
		}
		if (dayE < 1 || dayE > 31) {
		alert("Der Tag muss zwischen 1 and 31 liegen.");
		return "-2";
		}
		if ((monthE==4 || monthE==6 || monthE==9 || monthE==11) && dayE==31) {
		alert("Der Monat "+monthE+" hat 30 Tage!")
		return "-2";
		}
		if (monthE == 2) { // check for february 29th
		var isleap = (yearE % 4 == 0 && (yearE % 100 != 0 || yearE % 400 == 0));
		if (dayE>29 || (dayE==29 && !isleap)) {
		alert("Februar " + yearE + " hat nur " + dayE + " Tage!");
		return "-2";
		}
		}
		
		//sub 1 from monthE
		monthE = monthE.valueOf()-1;
		return new Date(yearE,monthE,dayE);
	}
	
	function calcDateDifference(releaseE, releaseF){
		var dateE = parseDate(releaseE);
		var dateF = parseDate(releaseF);
		//check if F is bigger than E
// 		alert(releaseE+" "+releaseF+ " "+dateE+" "+dateF);
		if(dateF == "-2")
			return "-3";
		if(dateE== "-2")
			return "-2";

		var diff = gregorianToJulian(dateF)-gregorianToJulian(dateE);
		return diff;
	}
	
	function addDays(date, days)
	{
	       if(date == "-2")
	               return "-2";
	       var dat = julianToGregorian(gregorianToJulian(date)+days);
// 	       alert("add days "+dat);
	       return dat;
	}

	function addDaysToString(date, days)
	{
	       var parsedDate = date;
	       
	       if(parsedDate == "-2")
	               return "-2";
	               
               return formatDate(addDays(date, days));
	}
	
	function formatDate(dat)
	{
	       var tmp = parseInt(dat.getMonth().valueOf()+1,10) + 100;
               var tmpString = tmp.toString(10);
               var month = tmpString.substring(1,5);
               var tmp = parseInt(dat.getDate(),10) + 100;
               var tmpString = tmp.toString(10);
               var day = tmpString.substring(1,5);
               var dateStr = dat.getFullYear()+"-"+month+"-"+day;
               return dateStr;
	}
	
	function createDate(string)
	{
	       return parseDate(string);
	}
	
	function calcDateDiffWithAlert(releaseE, releaseF){
		var dateE = parseDate(releaseE);
		var dateF = parseDate(releaseF);
		//check if F is bigger than E
		if(dateF == -2)
			return -3;
		if(dateE== -2)
			return -2;
		
		if(dateF.getTime()<dateE.getTime()){
			alert("Die Differenz zwischen Start- und Enddatum\n ist negativ. Bitte geben sie ein anderes Datum ein.");
			return false;
		}
		var diff = gregorianToJulian(dateF)-gregorianToJulian(dateE);
		return diff;
	
	}
	
	function gregorianToJulian(  dat )
	{
	var y = dat.getFullYear();
	var m =dat.getMonth().valueOf()+1;
	var d =dat.getDate();
	
	var c, ya;
	if ( y <= 99 )
		y += 2000;
	if ( m > 2 ) {
		m -= 3;
	} else {
		m += 9;
		y--;
	}
	c = y;
	c /= 100;
	c = Math.floor(c);
	ya = y - 100*c;
	return 1721119 + d + Math.floor((146097*c)/4) + Math.floor((1461*ya)/4) + Math.floor((153*m+2)/5);
	}
	
	/*!
	\internal
	Converts a Julian day to a Gregorian date.
	This algorithm is taken from Communications of the ACM, Vol 6, No 8.
	\sa gregorianToJulian()
	*/
	
	function julianToGregorian(  jd )
	{
	var x;
	var j = jd - 1721119;
	var y = Math.floor((j*4 - 1)/146097);
	j = j*4 - 146097*y - 1;
	x = Math.floor(j/4);
	j = Math.floor((x*4 + 3) / 1461);
	y = 100*y + j;
	x = (x*4) + 3 - 1461*j;
	x = Math.floor((x + 4)/4);
	var m = Math.floor((5*x - 3)/153);
	x = 5*x - 3 - 153*m;
	var d = Math.floor((x + 5)/5);
	if ( m < 10 ) {
		m += 3;
	} else {
		m -= 9;
		y++;
	}
	return new Date(Math.floor(y),Math.floor(m)-1,Math.floor(d));
	}
