//
// LightColorPicker -- a JAVAScript color picker for most purposes.
//
// $Id: LightColorPicker.js 56 2007-08-26 19:18:50Z wglas $
// 
// Tapestry Tools
// 
// Copyleft (C) 2007 IBCL and EV-i Informationstechnologie GmbH
//  
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//  
//     http://www.apache.org/licenses/LICENSE-2.0
//  
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//  
// Author: Wolfgang Glas/ev-i
// Created: 05.06.2007
// 
var tempX = 0;
var tempY = 0;

var isMSIE= (navigator.appName.indexOf("Explorer") > -1 ? true : false);

if (!isMSIE) document.captureEvents(Event.MOUSEMOVE);

// Set-up to use getMouseXY function onMouseMove
document.onmousemove = getMouseXY;

// Main function to retrieve mouse x-y pos.s

function getMouseXY(e) {
  if (isMSIE) { // grab the x-y pos.s if browser is IE
    tempX = window.event.clientX + document.body.scrollLeft;
    tempY = window.event.clientY + document.body.scrollTop;
  } else {  // grab the x-y pos.s if browser is NS
    tempX = e.pageX;
    tempY = e.pageY;
  }  
  // catch possible negative values in NS4
  if (tempX < 0){tempX = 0;}
  if (tempY < 0){tempY = 0;}  
}

var colorTarget;
var lcp_i18n_texts = new Object();

function fillColor(id,col)
{
   var target = document.getElementById("colTarget_"+id);
   var field = document.getElementById(id);
   if(!target) return;

   var inner = target.firstChild;
   if (inner) target.removeChild(inner);

   if (col && col.length == 7 && col.charAt(0) == '#')
   {
      target.style.backgroundColor = col;
      target.title = col;
      if (field) field.value=col;
   }
   else
   {
      target.style.backgroundColor = '#000000';
      inner = document.createElement("div");
      inner.className="nocolortarget";
      target.appendChild(inner);
      target.title = lcp_i18n_texts['no_color'];
      if (field) field.value='x';
   }
}

function selectColor(col,i)
{
   fillColor(colorTarget,col);
   if (i=="1") hideColorChooser(); 
}

function chooseColor(id)
{
  colorTarget = id;

  var chooser =  getColorChooser();

  var width;
  var height;
  
  if (isMSIE) {
  	width = document.body.offsetWidth;
  	height = document.body.offsetHeight;
  }	else {
    width = window.innerWidth;
    height = window.innerHeight;
  }

  var xpos = tempX;
  var ypos = tempY;

  if (xpos + 18*21+10 > width)
     xpos = width - (18*21+10);
 
  if (xpos<0) xpos = 0;
     
  if (ypos + 17*12+10 > height)
     ypos = height - (17*12+10);
     
  if (ypos<0) ypos = 0;
 
  chooser.style.visibility = 'visible';

  chooser.style.top  = ypos + 'px';
  chooser.style.left = xpos + 'px';
  chooser.style.position = 'absolute';
}

function hideColorChooser()
{
  var chooser =  getColorChooser();
  chooser.style.visibility = 'hidden';
}

function makeColorCell(row,col)
{
   var cell = document.createElement("td");
   cell.className="colorchart"; 
   cell.bgColor="#"+col;
   cell.onclick=function() { selectColor('#' + col,0); };
   cell.ondblclick=function() { selectColor('#' + col,1); };
   cell.title = col;
   row.appendChild(cell);
}

function getColorChooser()
{
   var chooser =  document.getElementById('colorChooser');

   if (chooser) return chooser;

   
   // Create the top-level div element
   chooser = document.createElement("div");
   chooser.id = "colorChooser";
   chooser.style.top  = tempY + 'px';
   chooser.style.left  = tempX + 'px';
   chooser.style.zIndex = "400";
	
   var tab = document.createElement("table");
   tab.border = 0;
   tab.cellPadding = 0;
   tab.cellSpacing = 1;
   tab.style.marginTop="0px";
   tab.style.marginBottom="0px";
   tab.style.backgroundColor="#444444";

   var tbody = document.createElement("tbody");

   var row;

row = document.createElement("tr");
   var cell = document.createElement("td");
   cell.className="colorchart"; 
   cell.colSpan=17;
   cell.bgColor="#3333CC";

   var span = document.createElement("span");
   span.className="nocolorchart";
   span.style.color="white";
   span.style.textDecoration="none";
   span.style.fontFamily="arial,helvetica,sans-serif";
   span.style.fontSize="12px";

   span.innerHTML=lcp_i18n_texts['color_selection'];

   cell.appendChild(span);

   row.appendChild(cell);

   cell = document.createElement("td");
   cell.style.backgroundColor="#3333CC";
   cell.align="center";

   var a = document.createElement("a");
   a.href="#";
   a.onclick= function(){hideColorChooser();};
   a.title="Schlie\337en";
   a.style.color="white";
   a.style.textDecoration="none";
   a.style.fontFamily="arial,helvetica,sans-serif";
   a.style.fontSize="10px";

   a.innerHTML="&#215;";

   cell.appendChild(a)
   row.appendChild(cell);

tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'330000');
makeColorCell(row,'333300');
makeColorCell(row,'336600');
makeColorCell(row,'339900');
makeColorCell(row,'33CC00');
makeColorCell(row,'33FF00');
makeColorCell(row,'66FF00');
makeColorCell(row,'66CC00');
makeColorCell(row,'669900');
makeColorCell(row,'666600');
makeColorCell(row,'663300');
makeColorCell(row,'660000');
makeColorCell(row,'FF0000');
makeColorCell(row,'FF3300');
makeColorCell(row,'FF6600');
makeColorCell(row,'FF9900');
makeColorCell(row,'FFCC00');
makeColorCell(row,'FFFF00');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'330033');
makeColorCell(row,'333333');
makeColorCell(row,'336633');
makeColorCell(row,'339933');
makeColorCell(row,'33CC33');
makeColorCell(row,'33FF33');
makeColorCell(row,'66FF33');
makeColorCell(row,'66CC33');
makeColorCell(row,'669933');
makeColorCell(row,'666633');
makeColorCell(row,'663333');
makeColorCell(row,'660033');
makeColorCell(row,'FF0033');
makeColorCell(row,'FF3333');
makeColorCell(row,'FF6633');
makeColorCell(row,'FF9933');
makeColorCell(row,'FFCC33');
makeColorCell(row,'FFFF33');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'330066');
makeColorCell(row,'333366');
makeColorCell(row,'336666');
makeColorCell(row,'339966');
makeColorCell(row,'33CC66');
makeColorCell(row,'33FF66');
makeColorCell(row,'66FF66');
makeColorCell(row,'66CC66');
makeColorCell(row,'669966');
makeColorCell(row,'666666');
makeColorCell(row,'663366');
makeColorCell(row,'660066');
makeColorCell(row,'FF0066');
makeColorCell(row,'FF3366');
makeColorCell(row,'FF6666');
makeColorCell(row,'FF9966');
makeColorCell(row,'FFCC66');
makeColorCell(row,'FFFF66');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'330099');
makeColorCell(row,'333399');
makeColorCell(row,'336699');
makeColorCell(row,'339999');
makeColorCell(row,'33CC99');
makeColorCell(row,'33FF99');
makeColorCell(row,'66FF99');
makeColorCell(row,'66CC99');
makeColorCell(row,'669999');
makeColorCell(row,'666699');
makeColorCell(row,'663399');
makeColorCell(row,'660099');
makeColorCell(row,'FF0099');
makeColorCell(row,'FF3399');
makeColorCell(row,'FF6699');
makeColorCell(row,'FF9999');
makeColorCell(row,'FFCC99');
makeColorCell(row,'FFFF99');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'3300CC');
makeColorCell(row,'3333CC');
makeColorCell(row,'3366CC');
makeColorCell(row,'3399CC');
makeColorCell(row,'33CCCC');
makeColorCell(row,'33FFCC');
makeColorCell(row,'66FFCC');
makeColorCell(row,'66CCCC');
makeColorCell(row,'6699CC');
makeColorCell(row,'6666CC');
makeColorCell(row,'6633CC');
makeColorCell(row,'6600CC');
makeColorCell(row,'FF00CC');
makeColorCell(row,'FF33CC');
makeColorCell(row,'FF66CC');
makeColorCell(row,'FF99CC');
makeColorCell(row,'FFCCCC');
makeColorCell(row,'FFFFCC');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'3300FF');
makeColorCell(row,'3333FF');
makeColorCell(row,'3366FF');
makeColorCell(row,'3399FF');
makeColorCell(row,'33CCFF');
makeColorCell(row,'33FFFF');
makeColorCell(row,'66FFFF');
makeColorCell(row,'66CCFF');
makeColorCell(row,'6699FF');
makeColorCell(row,'6666FF');
makeColorCell(row,'6633FF');
makeColorCell(row,'6600FF');
makeColorCell(row,'FF00FF');
makeColorCell(row,'FF33FF');
makeColorCell(row,'FF66FF');
makeColorCell(row,'FF99FF');
makeColorCell(row,'FFCCFF');
makeColorCell(row,'FFFFFF');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'0000FF');
makeColorCell(row,'0033FF');
makeColorCell(row,'0066FF');
makeColorCell(row,'0099FF');
makeColorCell(row,'00CCFF');
makeColorCell(row,'00FFFF');
makeColorCell(row,'99FFFF');
makeColorCell(row,'99CCFF');
makeColorCell(row,'9999FF');
makeColorCell(row,'9966FF');
makeColorCell(row,'9933FF');
makeColorCell(row,'9900FF');
makeColorCell(row,'CC00FF');
makeColorCell(row,'CC33FF');
makeColorCell(row,'CC66FF');
makeColorCell(row,'CC99FF');
makeColorCell(row,'CCCCFF');
makeColorCell(row,'CCFFFF');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'0000CC');
makeColorCell(row,'0033CC');
makeColorCell(row,'0066CC');
makeColorCell(row,'0099CC');
makeColorCell(row,'00CCCC');
makeColorCell(row,'00FFCC');
makeColorCell(row,'99FFCC');
makeColorCell(row,'99CCCC');
makeColorCell(row,'9999CC');
makeColorCell(row,'9966CC');
makeColorCell(row,'9933CC');
makeColorCell(row,'9900CC');
makeColorCell(row,'CC00CC');
makeColorCell(row,'CC33CC');
makeColorCell(row,'CC66CC');
makeColorCell(row,'CC99CC');
makeColorCell(row,'CCCCCC');
makeColorCell(row,'CCFFCC');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'000099');
makeColorCell(row,'003399');
makeColorCell(row,'006699');
makeColorCell(row,'009999');
makeColorCell(row,'00CC99');
makeColorCell(row,'00FF99');
makeColorCell(row,'99FF99');
makeColorCell(row,'99CC99');
makeColorCell(row,'999999');
makeColorCell(row,'996699');
makeColorCell(row,'993399');
makeColorCell(row,'990099');
makeColorCell(row,'CC0099');
makeColorCell(row,'CC3399');
makeColorCell(row,'CC6699');
makeColorCell(row,'CC9999');
makeColorCell(row,'CCCC99');
makeColorCell(row,'CCFF99');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'000066');
makeColorCell(row,'003366');
makeColorCell(row,'006666');
makeColorCell(row,'009966');
makeColorCell(row,'00CC66');
makeColorCell(row,'00FF66');
makeColorCell(row,'99FF66');
makeColorCell(row,'99CC66');
makeColorCell(row,'999966');
makeColorCell(row,'996666');
makeColorCell(row,'993366');
makeColorCell(row,'990066');
makeColorCell(row,'CC0066');
makeColorCell(row,'CC3366');
makeColorCell(row,'CC6666');
makeColorCell(row,'CC9966');
makeColorCell(row,'CCCC66');
makeColorCell(row,'CCFF66');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'000033');
makeColorCell(row,'003333');
makeColorCell(row,'006633');
makeColorCell(row,'009933');
makeColorCell(row,'00CC33');
makeColorCell(row,'00FF33');
makeColorCell(row,'99FF33');
makeColorCell(row,'99CC33');
makeColorCell(row,'999933');
makeColorCell(row,'996633');
makeColorCell(row,'993333');
makeColorCell(row,'990033');
makeColorCell(row,'CC0033');
makeColorCell(row,'CC3333');
makeColorCell(row,'CC6633');
makeColorCell(row,'CC9933');
makeColorCell(row,'CCCC33');
makeColorCell(row,'CCFF33');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'000000');
makeColorCell(row,'003300');
makeColorCell(row,'006600');
makeColorCell(row,'009900');
makeColorCell(row,'00CC00');
makeColorCell(row,'00FF00');
makeColorCell(row,'99FF00');
makeColorCell(row,'99CC00');
makeColorCell(row,'999900');
makeColorCell(row,'996600');
makeColorCell(row,'993300');
makeColorCell(row,'990000');
makeColorCell(row,'CC0000');
makeColorCell(row,'CC3300');
makeColorCell(row,'CC6600');
makeColorCell(row,'CC9900');
makeColorCell(row,'CCCC00');
makeColorCell(row,'CCFF00');
tbody.appendChild(row);

row = document.createElement("tr");
makeColorCell(row,'000000');
makeColorCell(row,'111111');
makeColorCell(row,'222222');
makeColorCell(row,'333333');
makeColorCell(row,'444444');
makeColorCell(row,'555555');
makeColorCell(row,'666666');
makeColorCell(row,'777777');
makeColorCell(row,'888888');
makeColorCell(row,'999999');
makeColorCell(row,'AAAAAA');
makeColorCell(row,'BBBBBB');
makeColorCell(row,'CCCCCC');
makeColorCell(row,'DDDDDD');
makeColorCell(row,'EEEEEE');
makeColorCell(row,'FFFFFF');

   cell = document.createElement("td");
   cell.bgColor="#000000";
   cell.className="nocolorchart";
   cell.colSpan=2;
   cell.title=lcp_i18n_texts['no_color'];
   cell.onclick=function() { selectColor(null,0); };
   cell.ondblclick=function() { selectColor(null,1); };

   var inner = document.createElement("div");
   inner.className="nocolorchartinner";

   cell.appendChild(inner);

   row.appendChild(cell);

   tbody.appendChild(row);
tab.appendChild(tbody);
   
   chooser.appendChild(tab);

   document.body.appendChild(chooser);
   return chooser;
}
